/*
 * Copyright (c) 2009 Anthony Steed and Manuel Fradinho Oliveira
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the 
 * following conditions are met:
 * 1. Redistributions of source code must retain the above
 *    copyright notice, this list of conditions and the 
 *    following disclaimer.
 * 2. Redistributions in binary form must reproduce the above 
 *    copyright notice, this list of conditions and the 
 *    following disclaimer in the documentation and/or other 
 *    materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of 
 *    this software must display the following acknowledgement:
 *       This product includes software from the book "Networked 
 *       Graphics" written by Anthony Steed and Manuel Fradinho
 *       Oliveira published by Morgan Kaufmann
 * 4. Neither the name of the University nor of the Department
 *    may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 5. Neither the name of Cyntelix may be used to enforese or 
 *    promote products derived from this software without prior
 *    written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE UNIVERSITY AND CONTRIBUTORS 
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, 
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO 
 * EVENT SHALL THE UNIVERSITY OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION). HOWEVER CAUSED 
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Contact Info: Anthony Steed
 *               a.steed@cs.ucl.ac.uk
 *
 *               Manuel Fradinho Oliveira
 *               mfradinho@cyntelix.com
 *
 */
import java.io.*;
import javax.vecmath.*;

public class ConfigP2PSimple extends Config {

  public ConfigP2PSimple(String str){
    super(str);
  }

  public void process(Datamodel datamodel, StreamTokenizer auxStream) {
    float   red;
    float   blue;
    float   green;
    int     id;
    int     input;
    int     port;
    String  ip;
    FlockRemote auxRemote = null;
    try {
      auxStream.nextToken();
      datamodel._numBoids = (int)auxStream.nval;
      input = auxStream.nextToken();
      id = (int)auxStream.nval;
      input = auxStream.nextToken();
      red = (float)auxStream.nval;
      input = auxStream.nextToken();
      green = (float)auxStream.nval;
      input = auxStream.nextToken();
      blue = (float)auxStream.nval;
      input = auxStream.nextToken();
      _port = (int)auxStream.nval;
      Flock auxFlock = new Flock(datamodel._numBoids, new Color3f(red, green, blue));
      auxFlock.setID(id);
      datamodel.setLocalFlock(auxFlock);
      input = auxStream.nextToken();
      while (input != StreamTokenizer.TT_EOF) {
        id = (int)auxStream.nval;
        input = auxStream.nextToken();
        red = (float)auxStream.nval;
        input = auxStream.nextToken();
        green = (float)auxStream.nval;
        input = auxStream.nextToken();
        blue = (float)auxStream.nval;
        input = auxStream.nextToken();
        ip = auxStream.sval;
        input = auxStream.nextToken();
        port = (int)auxStream.nval;
        auxRemote = new FlockRemoteFlag(datamodel._numBoids, new Color3f(red, green, blue));
        auxRemote.setID(id);
        auxRemote.setPort(port);
        auxRemote.setIP(ip);
        datamodel.addRemoteFlock(auxRemote);
        input = auxStream.nextToken();
      }
    } catch (Exception e) {
        e.printStackTrace();
    }
  }
}
